// Carpet Area Calculation v3.0 - more structured version
// Source is: 05_03.CPP

#include <iostream.h>

// Function prototype for Calculate_Area()
float Calculate_Area(int);

int main()
   {
   int   room, num_rooms;
   float total_area;

   cout << "Carpet Area Calculation\n";
   cout << "-----------------------\n";

   cout << "How many rooms (0 = QUIT)? : ";
   cin  >> num_rooms;

   for (room = 1; room <= num_rooms; room++)
      {
      // Keep a running total of the carpet area
      total_area += Calculate_Area(room);
      }

    if (num_rooms > 0)
      {
      cout << "\n\nTotal area of carpet required = " 
           << total_area << " square metres.\n\n";
      }
            
    cout << "Finished.";
 
    return 0;
    }

/***********************************************************
*                                                          *
*   FUNCTION:  Calculate_Area                              *
*                                                          *
*   OVERVIEW:  Calculate carpet area for one room.         *
*                                                          *
***********************************************************/
float Calculate_Area(int room_no)
    {
    float width, length, area;
 
    cout << "\nROOM " << room_no << "\n";
    cout << "Type in width (in metres) <RETURN>: ";
    cin  >> width;
    cout << "Type in length (in metres) <RETURN>: ";
    cin  >> length;

    area = width * length * 2; // Covering ceiling too.

    cout << "Area of carpet for Room " << room_no
         << " is: " << 2 * width * length << endl;

    return area;
    }
