// Initialising register variables 
// Source is: 06_13.CPP 

#include <iostream.h>
#include <time.h>

int main()
   {
   int automatic_int;
   register int register_int;
   
   const long NUM_PASSES = 100000000;
   double   elapsed_time;

   time_t   start_time, stop_time; // time_t is defined in time.h

   // METHOD ONE 
   cout << "Starting calculation - please wait...\n";
   start_time = time(NULL);  
   
   for (long pass = 0; pass <= NUM_PASSES; pass++)
      { 
      automatic_int = 10;
      }

   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Automatic, time (in seconds) : " << elapsed_time << endl; 
    
   // METHOD TWO 
   start_time = time(NULL);
   
   for (pass = 0; pass <= NUM_PASSES; pass++)
      { 
      register_int = 10;
      }
             
   stop_time = time(NULL);   
   elapsed_time = difftime(stop_time, start_time);
   cout << "Register, time (in seconds) : " << elapsed_time << endl; 
    
   return 0;    
   }
