// Playing with structs
// Source is: 17_01.CPP

#include <iostream.h>
#include <iomanip.h>

// Defining the user-defined data type number
struct sTwo_Numbers
   {
   int    int_num;
   double double_num;
   };

// Use typedef - see Ch.11
typedef sTwo_Numbers* sTwo_Numbers_PTR;

int main()
   {
   // Declare two variable of sTwo_Numbers
   sTwo_Numbers Nums_A, Nums_B;

   // Nums_A_PTR is a pointer to variable Nums_A, etc..
   sTwo_Numbers_PTR Nums_A_PTR;
   sTwo_Numbers_PTR Nums_B_PTR;

   Nums_A_PTR = &Nums_A;
   Nums_B_PTR = &Nums_B;

   // Now, store some data in the user-defined variables
   // Do this using the structure pointer operator
   // and the structure member operator
   Nums_A_PTR->int_num = 1;
   Nums_A_PTR->double_num = 2.0;

   Nums_B.int_num = 3;
   Nums_B.double_num = 4.0;
   
   // Adjust output format
   cout << setiosflags(ios::showpoint);
   
   // Now, print out the stored values, again
   // using both possible structure operators
   cout << "First Structure\n";
   cout << "The int element is : "
        << Nums_A.int_num << endl;
   cout << "The double element is : "
        << (*Nums_A_PTR).double_num << endl << endl;     
   
   cout << "Second Structure\n";
   cout << "The int element is : "
        << Nums_B_PTR->int_num << endl;
   cout << "The double element is : "
        << (*Nums_B_PTR).double_num;

   return 0;
   }
