// Playing with unions
// Source is: 17_02.CPP

#include <iostream.h> 
#include <iomanip.h>

// User-defined data structure (union)
union uOne_Number 
   {
   int   x;
   float y;
   };

int main()
   {
   uOne_Number value;

   // Show that fields are stored in overlapping memory locations
   cout << "Address of x field : " << &value.x << endl;
   cout << "Address of y field : " << &value.y << "\n\n";

   // Adjust output format
   cout << setiosflags(ios::showpoint);

   value.x = 100;
   cout <<  "Put a value in the integer member "
        <<  "and print both members.\n"
        <<  "int:   " << value.x << endl
        <<  "float: " << value.y << endl << endl;

   value.y = 100.0;
   cout <<  "Put a value in the float member "
        <<  "and print both members.\n"
        <<  "int:   " << value.x << endl
        <<  "float: " << value.y << endl << endl;

   return 0;
   }
