// Simple dynamic memory allocation
// Source is: 18_01.CPP

#include <iostream.h>
#include <stdlib.h> 
#include <string.h>

int main()
   {
   int*     dynamic_int_PTR;
   float*   dynamic_float_PTR;

   // Try to get some memory for an integer from free store
   if (!(dynamic_int_PTR = new int))
      {
      cerr << "*** Memory could not be allocated ***";
      exit (1);
      }
   else
      {
      cout  << "Memory dynamically allocated for an integer\n"
            << "Address is : " << dynamic_int_PTR << "\n\n";
      }      
      

   // Return memory to free store
   delete dynamic_int_PTR;
   dynamic_int_PTR = 0;   // Good practice!

   // Try to get some memory for a float from free store
   if (!(dynamic_float_PTR = new float))
      {
      cerr << "*** Memory could not be allocated ***";
      exit (1);
      }
   else
      {
      cout  << "Memory dynamically allocated for a float\n"
            << "Address is : " << dynamic_float_PTR << endl;
      }      

   // Return memory to free store
   delete dynamic_float_PTR;
   dynamic_float_PTR = 0;  // Good practice!
    
   return 0;
   }
