// Direct file access - fails with varying length records
// Source is: 19_05.CPP    

#include <fstream.h>
#include <iostream.h>

int main()
   {                          
   int      Number, Numbers[10] = {0,1,2,3333,4,5,600,7,8,99};
   fstream  file_pointer;  // A pointer to the file

   file_pointer.open("datafile.dat", ios::out | ios::in);

   if (!file_pointer.good())   
      {
      cout << "FATAL ERROR: Could not create file 'datafile.dat'";
      return 1; 
      }

   cout << "Just opened the data file\n";

   // "Direct" access...
   for (int i = 0; i <= 9; i++)
       { 
       // This can't work!!  sizeof int is not the same as the 
       // (varying) size of the text equivalent.
       file_pointer.seekg(i * sizeof(int), ios::beg);
       file_pointer << Numbers[i];
       cout  << "Just written " << Numbers[i]
             << " at position " << i  << endl;
       }

   file_pointer.seekg(0 * sizeof(int), ios::beg);
   file_pointer >> Number;
   cout  << "\nJust read " << Number << " at position 0\n";

   file_pointer.seekg(3 * sizeof(int), ios::beg);
   file_pointer >> Number;
   cout  << "Just read " << Number << " at position 3\n";

   file_pointer.seekg(4 * sizeof(int), ios::beg);
   file_pointer >> Number;
   cout  << "Just read " << Number << " at position 4\n";

   file_pointer.seekg(6 * sizeof(int), ios::beg);
   file_pointer >> Number;
   cout  << "Just read " << Number << " at position 6\n";

   // Finished: close the file
   file_pointer.close();
         

   return 0;
   }
