// Simple direct file access using binary files
// Source is: 19_06.CPP

#include <fstream.h>
#include <iostream.h>

int main()
   {                          
   int      Number, Numbers[10] = {0,1,2,3333,4,5,600,7,8,99};
   fstream  file_pointer;  // A pointer to the file

   file_pointer.open("datafile.dat", ios::out|ios::in|ios::binary);

   if (!file_pointer.good())   
      {
      cout << "FATAL ERROR: Could not create file 'datafile.dat'";
      return 1; 
      }

   cout << "Just opened the data file\n";

   // "Direct" access...
   for (int i = 0; i <= 9; i++)
       {
       file_pointer.seekg(i * sizeof(int), ios::beg);
       file_pointer.write((char*) (Numbers+i), sizeof(int));
       cout  << "Just written " << Numbers[i]
             << " at position " << i << endl;
       }

   file_pointer.seekg(0 * sizeof(int), ios::beg);
   file_pointer.read((char*) &Number, sizeof(int));
   cout  << "\nJust read " << Number << " at position 0\n";

   file_pointer.seekg(3 * sizeof(int), ios::beg);
   file_pointer.read((char*) &Number, sizeof(int));
   cout  << "Just read " << Number << " at position 3\n";

   file_pointer.seekg(4 * sizeof(int), ios::beg);
   file_pointer.read((char*) &Number, sizeof(int));
   cout  << "Just read " << Number << " at position 4\n";

   file_pointer.seekg(6 * sizeof(int), ios::beg);
   file_pointer.read((char*) &Number, sizeof(int));
   cout  << "Just read " << Number << " at position 6\n";

   // Finished: close the file
   file_pointer.close();
         

   return 0;
   }
