// A first simple class and object example
// Source is: 24_01.CPP

#include <iostream.h>

class cFirst_Class
   {
   public:
      // Public member functions
      void Set_Num(const int); // Mutator member function
      void Show_Num() const;   // Accessor member function
   private:
      // Private data
      int _Num;
   };   

// Member functions
// Note use of scope resolution operator

// Mutator member function
void cFirst_Class::Set_Num(const int NUMBER)
   {
   _Num = NUMBER;
   }

// Accessor member function (note const)
// N.B. Cannot change private data
void cFirst_Class::Show_Num() const
   {
   cout << "Number is " << _Num;
   }


int main(void)
   {
   // Create an object of type cFirst_Class
   cFirst_Class Object;
   
   // Call the Set_Num() mutator function
   Object.Set_Num(9);
   
   // Call the Show_Num() accessor function
   Object.Show_Num();
   
   return 0;
   }
