// A class example using a destructor - v2.0
// Source is: 25_08.CPP

#include <iostream.h>
#include <stdlib.h>

class cDynamic
   {
   public:
           cDynamic(const int = 0); // Constructor
           ~cDynamic();             // Destructor
           
      int  Show_Num() const;
      void Set_Num(const int); 
      
   private:
      int* _Num_PTR;
   };   

cDynamic::cDynamic(const int NUMBER)
   {
   cout << "\n*** Constructing a cDynamic object (" 
        << NUMBER << ") ***\n\n"; 
   
   _Num_PTR = new int;
   
   if (_Num_PTR == 0)
      {
      cerr << "Unable to allocate memory - aborting program\n";
      exit(1);
      }
   else
      {   
      *_Num_PTR = NUMBER;
      }
   }
                     
cDynamic::~cDynamic()
   {
   cout << "\n*** Destructing a cDynamic object ***\n\n"; 
   
   delete _Num_PTR;
   _Num_PTR = 0;
   }

int cDynamic::Show_Num() const
   {
   return *_Num_PTR;
   }

void cDynamic::Set_Num(const int NUM)
   {
   *_Num_PTR = NUM;
   }

int main()
   {
   cDynamic Object1 = 9;
   
   // Anonymous block
      {
      cDynamic Object2 = Object1;  // Copy object 1??
   
      cout << "Object1 : " << Object1.Show_Num();
      
      cout << "\n\nSet_Numting Object2 private data to 4\n";
      Object2.Set_Num(4);
      
      cout << "Object2 : " << Object2.Show_Num() << endl;
      }

   cout << "Object1 : " << Object1.Show_Num() << endl;
   
   return 0;
   }
