// Program to illustrate exception handling.
// Source is: 25_14.CPP

#include <iostream.h>
#include <string.h>
#include <ctype.h>

int main()
  {
  char  Name[80];
  char* Ch_PTR;
  int   Age;
  
  // The user is asked to input the name and age of an 
  // employee - exceptions are generated and the program
  // exits if the name or age is not sensible.
  
  cout << "What is the employee's name? ";
  cin.getline(Name, 80);
  
  cout << "How old are they? ";
  cin  >> Age;
  
  try
     {
     if (Age < 16) 
        {
        throw -1;
        }
       
     if (Age > 60) 
        {
        throw 1;
        }
       
     if (strlen(Name) == 0) 
        {
        throw 's';
        }
       
     Ch_PTR = Name;
    
     while (*Ch_PTR != '\0')
       {
       if (!isalpha(*Ch_PTR) && (*Ch_PTR != ' ')) 
          {
          throw *Ch_PTR;
          }
         
       Ch_PTR++;
       }  
     }
  
  // An integer exception will be thrown if the age input
  // is less than 16 or greater than 60.
  catch (int i)
     {
     if (i == -1)
       {
       cout << "You are too young to work for us." << endl;
       }
    
    if (i == 1)
       {
       cout << "You are too old to work for us." << endl;
       }
    
    // Quit the program.
    return 1; 
    }
  
  catch (char c)
     {
     if (c == 's')
        {
        cout << "No name entered." << endl;
        }
     else
        {
        cout << "Non-alphabetical character " << c  
             << " found." << endl;
        }
    
     return 1;
     }
    
   // The program will only reach this point if no exceptions have
   // been found.
   cout << "Employee " << Name << " is " << Age << " years old" << endl;

   return 0;
   }
