// Simple use of friend functions
// Source is: 26_02.CPP

#include <iostream.h>

class cClass
   {
   public:
             void set(int);       // Member function

      friend void show(cClass);   // Friend function
   private:
      int _num;
   };   

void cClass::set(int number)
   {
   _num = number;
   }

int main()
   {
   cClass Object;
   
   Object.set(2001);
   
   // Call the show friend function
   show(Object);
   
   return 0;
   }

// Friend (ordinary) function definition
// NB: no scope resolution operator &c 
// NB: no mention of "friend" here
void show(cClass Object)
   {
   cout << "Using friend function, number is " << Object._num;
   }
