// Another use of friend functions
// Here friend is an ordinary function linking two classes
// Source is: 26_03.CPP

#include <iostream.h>

class cClass2; // Forward reference

class cClass1
   {
   public:
             void set(int);

      friend void show(cClass1,cClass2); 
   private:
      int _num;
   };   

void cClass1::set(int number)
   {
   _num = number;
   }

class cClass2
   {
   public:
             void set(int);       

      friend void show(cClass1, cClass2);
   private:
      int _num;
   };   

void cClass2::set(int number)
   {
   _num = number;
   }

int main()
   {
   cClass1 O1;
   cClass2 O2;
   
   O1.set(2001);
   O2.set(1999);
   
   // Call the show friend function
   show(O1,O2);
   
   return 0;
   }

// Friend (ordinary) function definition
void show(cClass1 x, cClass2 y)
   {
   cout << "Friendly sum is " << x._num + y._num;
   }
