// A simple money class with copy constructor and overloaded = operator
// Source is: 27_07.CPP

#include <iostream.h>

class cMoney
   {
   public:
            cMoney(const int = 0, const int = 0);
            cMoney(cMoney&);
              
      void  Show() const;
      
      void  operator=(const cMoney&);
      
   private:
      int   _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   cout << "*** Ordinary constructor ***\n";
   
   _Pounds = PO;
   _Pence = PE;
   }   
   
cMoney::cMoney(cMoney& OBJ2)
   {
   cout << "*** Copy constructor ***\n"; 
   
   _Pounds = OBJ2._Pounds;
   _Pence = OBJ2._Pence;
   }   
   
void cMoney::Show() const
   {
   if (_Pence < 10)
      {
      cout << "" << _Pounds << ".0" << _Pence << endl;
      }
   else
      {
      cout << "" << _Pounds << "." << _Pence << endl;
      }   
   }        

// Overload = relative to cMoney class (simple version)
void cMoney::operator=(const cMoney& OBJ2)
   {
   cout << "*** Overloaded assignment operator ***\n";

   _Pounds = OBJ2._Pounds;
   _Pence = OBJ2._Pence;
   }

int main()
   {
   cout << "cMoney cash1(1,33);\n";
   cMoney cash1(1,33);

   cout << "\ncMoney cash2 = cash1\n";
   cMoney cash2 = cash1;

   cout << "\ncash1 = cash2;\n";
   cash1 = cash2;

   return 0;
   }
