// A simple money class with overloaded * operators
// implemented as friend functions
// Source is: 27_09.CPP

#include <iostream.h>

class cMoney
   {
   public:
                    cMoney(const int = 0, const int = 0); 
                    
               void Show();
               
             cMoney operator*(const int) const;          // Mult object * int
      friend cMoney operator*(const int, const cMoney&); // Mult int * object 
      
   private:
      int _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   _Pounds = PO;
   _Pence = PE;
   }   
   
void cMoney::Show()
   {
   if (_Pence < 10)
      {
      cout << "" << _Pounds << ".0" << _Pence << endl;
      }
   else
      {
      cout << "" << _Pounds << "." << _Pence << endl;
      }   
   }        
   
// Overload * for cMoney class plus int
cMoney cMoney::operator*(const int MULTIPLIER) const
   {
   cMoney Product;
   
   Product._Pounds = this->_Pounds * MULTIPLIER;
   Product._Pence = this->_Pence * MULTIPLIER;

   while (Product._Pence > 99)
      {
      Product._Pence-=100;
      Product._Pounds+=1;
      }     

   return Product;
   }

// Overload * for int plus cMoney class (again)
cMoney operator*(const int MULTIPLIER, 
                 const cMoney& OBJECT)
   {
   cMoney Product;
   
   Product._Pounds = OBJECT._Pounds * MULTIPLIER;
   Product._Pence = OBJECT._Pence * MULTIPLIER;
   
   while (Product._Pence > 99)
      {
      Product._Pence-=100;
      Product._Pounds+=1;
      }     

   return Product;
   }
   
int main()
   {
   cMoney cash1(1,33), cash2;
   
   cash2 = cash1 * 10;  
   cash2.Show(); 
   
   cash2 = 10 * cash1;
   cash2.Show();
   
   return 0;
   }
