// A simple generic function
// Source is: 28_01.CPP

#include <iostream.h>

// Declaration of Copy()
template <typename TYPE> 
void Copy(TYPE* const, const TYPE* const, const int); 

int main()
   {
   int Int1[5] = {99,99,99,99,99};
   int Int2[5] = {1,2,3,4,5};

   char Char1[6] = "XXXXX";
   char Char2[6] = "Hello";

   cout << "Before copying :\n";
   for (int p = 0; p < 5; ++p)
      {
      cout << Int1[p] << " ";
      }
   cout << endl;

   cout << Char1 << endl << endl;

   Copy(Int1,Int2,5);   // Copy int arrays
   Copy(Char1,Char2,5); // Copy char arrays

   cout << "After copying :\n";
   for (p = 0; p < 5; ++p)
      {
      cout << Int1[p] << " ";
      }
   cout << endl;

   cout << Char1 << endl;

   return 0;
   }

// The definition of generic function Copy()
template <typename TYPE>
void Copy(TYPE* const To_PTR, const TYPE* const FROM_PTR, const int SIZE) 
   {
   for (int Element = 0; Element < SIZE; Element++)
      {
      To_PTR[Element] = FROM_PTR[Element];
      } 
   }
