// A simple generic function
// Source is: 28_02a.CPP

//
// Version of 28_02.CPP compatible with older C++ compilers
// - See ReadMe28.txt for details
//  

#include <iostream.h>

// Declaration of Copy() - v2.0
template <typename T1,  typename T2> 
void Copy(T1* const To_PTR, const T2* const FROM_PTR, const int SIZE); 

int main()
   {
   int   Ints[5] = {99,99,99,99,99};
   float Floats[5] = {0.0f};

   cout << "Before copying :\n";
   for (int p = 0; p < 5; ++p)
      {
      cout << Floats[p] << " ";
      }
   cout << endl;

   // Try to copy int array to float array...
   Copy(Floats, Ints, 5); 

   cout << "After copying :\n";
   for (p = 0; p < 5; ++p)
      {
      cout << Floats[p] << " ";
      }
   cout << endl;

   return 0;
   }

// The generic function Copy() - v2.0
template <typename T1,  typename T2>
void Copy(T1* const To_PTR, const T2* const FROM_PTR, const int SIZE) 
   {
   for (int Element = 0; Element < SIZE; ++Element)
      {
      To_PTR[Element] = FROM_PTR[Element];
      } 
   }
