// Playing with virtual functions
// Source is: 29_12.CPP

#include <iostream.h>

class cBase_Class 
   {
   public:
                   cBase_Class(const int I = 999) {_Bas = I;}
      // virtual needed here
      virtual void Show() const {cout << "_Bas = " << _Bas << endl;}

   private:
      int _Bas;
   };

class cDerived_Class : public cBase_Class 
   {
   public:
           cDerived_Class(const char CH = 'D') {_Der = CH;}
      void Show() const {cout << "_Der = " << _Der << endl;}

   private:
      char _Der;
   };

int main()
   {
   cBase_Class Base_object;
   cDerived_Class Derived_object;

   cBase_Class* Base_PTR;      // Pointer variable 

   Base_PTR = &Base_object;    // Points to object of BASE class
   cout << "Calling the cBase_Class Show()\n";
   Base_PTR->Show();   

   Base_PTR = &Derived_object; // Points to object of DERIVED class
   cout << "\nCalling the cDerived_Class Show().\n";
   Base_PTR->Show(); 
   
   return 0;
   }
