// A simple example of run-time polymorphism
// Source is: 29_14.cpp
#include <iostream.h>

class cSymbol
   {
   public:
      virtual void Draw() { cout << "Draw nothing here..." << endl; }
   };

class cTerminator : public cSymbol
   {
   public:
      void Draw() { cout << "Draw terminator here" << endl; }
   };

class cProcess : public cSymbol
   {
   public:
      void Draw() { cout << "Draw process here" << endl; }
   };

int main()
   {
   cSymbol* SymbolArray[10];
   
   int Choice;

   for (int Index = 0; Index < 10; Index++)
      {
      cout << "Type 1 for Term, 2 for Proc :  ";
      cin >> Choice;

      switch(Choice)
         {
         case 1:
            SymbolArray[Index] = new cTerminator;
            break;

         case 2:
            SymbolArray[Index] = new cProcess;
            break;
         }
      }

   for (Index = 0; Index < 10; Index++)
      {
      SymbolArray[Index]->Draw();
      }

   return 0;
   }
