// Program to find the sum of the squares of two numbers
// This time with error detection & recovery
// Source is: 06_15.CPP

#include <iostream.h>
#include <limits.h>

// Function declaration
int Sum_of_Squares5(int, int, int&);

int main()
    {
    int Num_1, Num_2;
    int Result;
    int return_value;  // Stores return value

    do
       {
       cout << "Type first number : ";
       cin >> Num_1;
       cout << "Type second number : ";
       cin >> Num_2;

       // Call function and check return code value
       return_value = Sum_of_Squares5(Num_1, Num_2, Result);
       } while (return_value != 0);
     
    return 0;
    }
 
/***********************************************************
*   FUNCTION:  Sum_of_Squares5                             *
*                                                          *
*   OVERVIEW:  To calculate the sum of the squares         *
*              of a and b (both integers) returning the    *
*              result via reference variable sum_REF       *
*                                                          *
*   RETURNS:   0  on normal completion.                    *
*              1  if numbers too large (sum_REF =0)        *
***********************************************************/
int Sum_of_Squares5(int a, int b, int& sum_REF)
    {
    float test = ((float) a * a) + ((float) b * b);

    if (test > INT_MAX)
       {
       // Numbers too large: can't represent result as int
       cerr << "\n*** Numbers too large! ***\n\n";
       sum_REF = 0;
       return 1;  // return 1 to indicate error
       }
    else
       {
       sum_REF = (int) test;
       cout << "Sum of squares is : " << sum_REF;
       return 0;  // return 0 - everything is OK
       }     
    }
