// Access times for various data types
// Source is: 07_02.CPP

#include <iostream.h>
#include <time.h>

int main()
   {

   const long  NUM_PASSES = 2000000;

   double   elapsed_time;
   time_t   start_time, stop_time; // time_t is defined in time.h

   // Using char 
   start_time = time(NULL);
   
   int x = 0;
   for (long pass = 0; pass <= NUM_PASSES; pass++)
      { 
      for (char char1 = 0; char1 <= 100; char1++)
         {
         x++;
         }
      }
 
   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Using char, time (in seconds) : " 
        << elapsed_time << endl; 


   // Using int
   start_time = time(NULL);

   x = 0;
   for (pass = 0; pass <= NUM_PASSES; pass++)
      { 
      for (int int1 = 0; int1 <= 100; int1++)
         {
         x++;
         }
      }
 
   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Using int, time (in seconds) : " 
        << elapsed_time << endl; 

   // Using long
   start_time = time(NULL);

   x = 0;
   for (pass = 0; pass <= NUM_PASSES; pass++)
      { 
      for (long int1 = 0; int1 <= 100; int1++)
          {
         x++;
         }
      }
 
   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Using long, time (in seconds) : " 
        << elapsed_time << endl; 

   return 0;
   }
