// Using function pointers
// Source is: 07_20.CPP

#include <iostream.h>

int squared(int, int&);

int main()
   {
   int a,b;   
   int (* p)(int, int&); /* Declares p to be a pointer to fn with
                          * int and int ref parameters
                          * (returning an int)  */
   int result_a, result_b;
   int* q;

   a = 7;
   b = 8;
   p = squared;   // p has address of fn. squared()
   q = &a;

   cout << "Function code starts at address: " << p << endl;

   cout << "Data item a starts at address: " << q << endl;

   if (squared(a,result_a))
      {
      cerr << "WARNING: Error in function squared.";
      }

   if ((*p)(b,result_b))
      {
      cerr << "WARNING: Error in squared.";
      }
                      
   cout << a << " squared is " << result_a
        << " (using normal function call)\n";
   cout << b << " squared is " << result_b
        << " (using function pointer)\n";

   return 0;
   }

int squared(int a, int& b)
   {
   b = a * a;

   return 0;
   }
