// Passing a 1-D Array to a Function
// First version
// Source is: 08_03.CPP

#include <iostream.h>

// Function prototype for Sum_of_Elements()
void Sum_of_Elements(int Int_Array[3]);

int main()
    {
    int i, Int_Array[3] = {1,2,3};
 
    // Print out array Contents
    cout << "Just about to call Sum_of_Elements...\n";
    for (i=0; i < 3; i++)
        {
        cout << "Array element " << i << " is " 
             << Int_Array[i] << endl;
        }
 
    // Call Sum_of_Elements
    Sum_of_Elements(&Int_Array[0]);

    cout << "\nAfter calling Sum_of_Elements...\n";
    for (i=0; i < 3; i++)
        {
        cout << "Array element " << i << " is " 
             << Int_Array[i] << endl;
        }
    
    return 0;
    }
 
/***********************************************************
*   FUNCTION:  Sum_of_Elements                             *
*                                                          *
*   OVERVIEW:  To calculate the sum of the elements        *
*              in a 1-D array.                             *
***********************************************************/
void Sum_of_Elements(int Array[3])
    {
    int i, sum = 0;
 
    for (i=0; i < 3; i++)
        {
        sum += Array[i];
        }
 
    for (i=0; i < 3; i++)
        {
        Array[i] = sum;
        }
    }     
