// Passing a 2-D Array to a Function
// Source is: 08_05.CPP

#include <iostream.h>

// Function prototype for Sum_of_Elements_2D()
void Sum_of_Elements_2D(int* const, const int, const int);

int main()
    {
    int i,j, Int_Array[2][3] = {{1,2,3},
                              {4,5,6}};
 
    // Print out array Contents
    cout << "Just about to call Sum_of_Elements_2D...\n";
    for (i=0; i < 2; i++)
        {
        for (j=0; j < 3; j++)
            {
            cout << "Array element [" << i << "," << j 
                 << "] is " << Int_Array[i][j] << endl;
            }
        }
 
    // Call Sum_of_Elements_2D
    Sum_of_Elements_2D(&Int_Array[0][0], 2, 3);

    // Print out array Contents
    cout << "\nAfter calling Sum_of_Elements_2D...\n";
    for (i=0; i < 2; i++)
        {
        for (j=0; j < 3; j++)
            {
            cout << "Array element [" << i << "," << j 
                 << "] is " << Int_Array[i][j] << endl;
            }
        }
    
    return 0;
    }
 
/***********************************************************
*   FUNCTION:  Sum_of_Elements_2D()                        *
*                                                          *
*   OVERVIEW:  To calculate the sum of the elements        *
*              in a 2-D array, and set each element        *
*              of the array to this value.                 *
***********************************************************/
void Sum_of_Elements_2D(int* const Int_PTR, 
                        const int  ROWS, 
                        const int  COLUMNS)
    {
    int i,j, sum = 0;
 
    for (i=0; i < ROWS; i++)
        {
        for (j=0; j < COLUMNS; j++)
            {
            sum += *(Int_PTR + (i * COLUMNS) + j);
            }
        }
     
    for (i=0; i < ROWS; i++)
        {
        for (j=0; j < COLUMNS; j++)
            {
            *(Int_PTR + (i * COLUMNS) + j) = sum;
            }
        }
    }     
