// Program to find the sum of the squares of two numbers
// This time returning data and error code
// Source is: 08_06.CPP

#include <iostream.h>
#include <limits.h>

// Function declaration
int Sum_of_Squares10(const int, const int);

int main()
    {
    int Num_1;
    int Num_2;
    int Result;

    cout << "Two integers, please : ";
    cin >> Num_1 >> Num_2;

    Result = Sum_of_Squares10(Num_1, Num_2);
    
    if (Result < 0) 
       {
       cout << "Sorry - reult could not be calculated.";
       }
    else
       {
       cout << "Result is " << Result;
       }

    return 0;
    }
 
/***********************************************************
*   FUNCTION:  Sum_of_Squares10                            *
*                                                          *
*   OVERVIEW:  To calculate the sum of the squares         *
*              of A and B (both integers) returning the    *
*              result                                      *
*                                                          *
*   RETURNS:   Sum of squares on normal completion.        *
*              -1 if numbers too large                     *
***********************************************************/
int Sum_of_Squares10(const int A, const int B)
    {
    float test = ((float) A * A) + ((float) B * B);

    if (test > INT_MAX)
       {
       // Numbers too large: can't represent result as int
       return -1;
       }
    else
       {
       return (int) test;
       }     
    }
