// Using library functions for robust data input
// Source is: 09_13.CPP

// Use: strcmp, toupper, getline, sscanf, strlen

#include <string.h>
#include <iostream.h>
#include <ctype.h>

int main()
   {
   char line[81];
   char* c_PTR; 
   int count = 0;
   char user_wants_to_continue;  // Flag
   char answer;
   
   do
      {     
      cout << "Type 'start', then <ENTER> to start count ";
      cin.getline(line, sizeof(line));

      // Convert input to upper case
      for(c_PTR = line; c_PTR < line + strlen(line); c_PTR++)
         {
         *c_PTR = toupper(*c_PTR);
         } 
      } while (strcmp(line, "START"));

      
   do
      {
      // Start counting...
      cout << "Count is : " << count++ << endl;
      
      if (!(count % 2))
         {
         do
            {
            cout << "Do you want to continue (Y/N) : ";
            cin.getline(line, sizeof(line));
            answer = toupper(line[0]);
            } while ((answer != 'Y') && (answer != 'N'));
         
         user_wants_to_continue = (answer == 'Y');
         
         }
      else
         {
         do
            {
            cout << "Hit <RETURN> to continue ";
            cin.getline(line, sizeof(line));
            } while (strlen(line));

         user_wants_to_continue = 1;
         } 
      } while (user_wants_to_continue);
   
   return 0;
   }
