/***********************************************************
*                                                          *
*   SOURCE: 11_01b.CPP                                     *
*                                                          *
***********************************************************/

#include <iostream.h>
#include "11_01.H"    // Project header file

/***********************************************************
*                                                          *
*  CppSpec:    Get_two_numbers()                           *
*                                                          *
*  OVERVIEW:   Prompts the user for two positive digits    *
*              (0-9), returning the result via char        *
*              reference variables digit1_REF and          *
*              digit2_REF.  Keeps prompting until valid    *
*              input is received.                          *
*                                                          *
*  PRE:        None.                                       *
*  POST:       Got two valid digits.                       *
*                                                          *
*  RETURN:     None.                                       *
*                                                          *
***********************************************************/
void Get_two_numbers(char& digit1_REF, char& digit2_REF)
   {
   digit1_REF = 0;
   digit2_REF = 0;

   cout << "*** FUNCTION: Get_two_numbers()\n";
   cout << "*** Returning 0 and 0\n\n";
   }

/***********************************************************
*                    *** END OF FILE ***                   *
***********************************************************/
