// Simple sequential file access with text files 
// Source is: 19_01.CPP

#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>

int main ()
   {
   int      Numbers[5] = {10,20,30,40,50};   
   fstream  file_pointer; 
   int      number, i;  

   // Open the data file for writing 
   file_pointer.open("datafile.dat", ios::out);   

   if (!file_pointer.good())   
      {
      cout << "FATAL ERROR: Could not create file 'datafile.dat'";
      exit(1); 
      }

   cout << "Just opened the data file for WRITING\n";

   for (i=0; i < 5; i++)
      {
      file_pointer << Numbers[i] << endl;    // Write data 
      cout  << "Just written : " << Numbers[i] << endl;
      }

   file_pointer.close(); // Finished writing: close the file 

                         
   // Open the file again, this time for reading                     
   file_pointer.open("datafile.dat", ios::in);   

   if (!file_pointer.good())   
      {
      cout << "FATAL ERROR: Could not open file 'datafile.dat'";
      exit(1);
      } 

   cout << "\nJust opened the data file for READING\n";

   for (i=0; i < 5; i++)
       {
       file_pointer >> number;    // Read data 
       cout << "Just read : " << number << endl;
       }   
            
   file_pointer.close();  // Don't forget to close the file 
   
   return 0;
   }
