// Simple file copy program for text files
// Source is: 19_02.CPP  

#include <iostream.h>
#include <fstream.h>

int main()
   {
   fstream orig_file_pointer, copy_file_pointer;

   orig_file_pointer.open("orig.txt", ios::in);
   copy_file_pointer.open("copy.txt", ios::out);   
      
   if ((!orig_file_pointer) || (!copy_file_pointer))
      {
      cerr << "ERROR: Cannot open an essential file.";
      return 1; // Note use of this alternative to exit()
      } 
   
   //Ignore white space in input
   orig_file_pointer.unsetf(ios::skipws);

   char ch;

   orig_file_pointer >> ch;

   while (!orig_file_pointer.eof())  // Keep going till end of file...
      {
      copy_file_pointer << ch;
      orig_file_pointer >> ch;
      }
       
   return 0;
   }
