// Simple direct file access
// Source is: 19_04.CPP 

#include <fstream.h>
#include <iostream.h>

int main ()
   {                          
   char      Character, characters[7] = {'a','b','c','d','e','f','g'};
   fstream  file_pointer;  // A pointer to the file

   file_pointer.open("datafile.dat", ios::out | ios::in);

   if (!file_pointer.good())   
      {
      cout << "FATAL ERROR: Could not create file 'datafile.dat'";
      return 1; 
      }

   cout << "Just opened the data file\n";

   for (int i = 0; i <= 6; i++)
       {
       file_pointer.seekg(i * sizeof(char), ios::beg);
       file_pointer << characters[i];
       cout  << "Just written " << characters[i]
             << " at position " << i  << endl;
       }

   file_pointer.seekg(6 * sizeof(char), ios::beg);
   file_pointer >> Character;
   cout  << "\nJust read " << Character << " at position 6\n";

   file_pointer.seekg(2 * sizeof(char), ios::beg);
   file_pointer >> Character;
   cout  << "Just read " << Character << " at position 2\n";

   file_pointer.seekg(5 * sizeof(char), ios::beg);
   file_pointer >> Character;
   cout  << "Just read " << Character << " at position 5\n";

   file_pointer.seekg(0 * sizeof(char), ios::beg);
   file_pointer >> Character;
   cout  << "Just read " << Character << " at position 0\n";

   // Finished: close the file
   file_pointer.close();
         

   return 0;
   }
