// A class example using a destructor
// Source is: 25_05.CPP

#include <iostream.h>
#include <stdlib.h>

class cDynamic
   {
   public:
           cDynamic(int = 0); // Constructor
           ~cDynamic();       // Destructor
      void Show_Num() const; 
   private:
      int* _Num_PTR;
   };   

cDynamic::cDynamic(int NUMBER)
   {
   cout << "Constructing a cDynamic object (" << NUMBER << ")" << endl; 
   _Num_PTR = new int;
   
   if (_Num_PTR == 0)
      {
      cerr << "Unable to allocate memory - aborting program\n";
      exit(1);
      }
   else
      {   
      *_Num_PTR = NUMBER;
      }
   }

cDynamic::~cDynamic()
   {
   cout << "Destructing a cDynamic object\n"; 
   delete _Num_PTR;
   _Num_PTR = 0;
   }

void cDynamic::Show_Num() const
   {
   cout << "Number is " << *_Num_PTR << endl;
   }

int main()
   {
   cDynamic Object1, Object2(3);
   
   // Display the private data for each object
   Object1.Show_Num();
   Object2.Show_Num();
   
   // NOTE - destructor is never (apparently) called...
   return 0;
   }
