// Passing objects to functions by reference
// Source is: 25_06.CPP

#include <iostream.h>

class cClass
   {
   public:
           cClass() { cout << "Construct!" << endl; }
           ~cClass() { cout << "Destruct!" << endl; } 
           
      void Set_Num(const int);
      void Show_Num() const; 

   private:
      int  _Num;
   };   

void cClass::Set_Num(const int NUMBER)
   {
   _Num = NUMBER;
   }

void cClass::Show_Num() const
   {
   cout << "Number is " << _Num << endl;
   }

void Ordinary_Function(cClass&);

int main()
   {
   cClass Object;

   Object.Set_Num(9);
   Object.Show_Num();

   Ordinary_Function(Object);

   Object.Show_Num();
   return 0;
   }

void Ordinary_Function(cClass& FunctionObject_REF)
   {
   cout << "Just entered function\n"; 
   
   FunctionObject_REF.Set_Num(30);
   FunctionObject_REF.Show_Num();   
   
   cout << "Just about to leave function\n"; 
   }
