// Passing Function_Objects to functions by value
// Source is: 25_07.CPP

#include <iostream.h>

class cClass
   {
   public:
           cClass() { cout << "Construct!" << endl; }
           ~cClass() { cout << "Destruct!" << endl; } 
           
      void Set_Num(const int);
      void Show_Num() const; 

   private:
      int  _Num;
   };   

void cClass::Set_Num(const int NUMBER)
   {
   _Num = NUMBER;
   }

void cClass::Show_Num() const
   {
   cout << "Number is " << _Num << endl;
   }

void Ordinary_Function(cClass);

int main()
   {
   cClass Function_Object;

   Function_Object.Set_Num(9);
   Function_Object.Show_Num();

   Ordinary_Function(Function_Object);

   Function_Object.Show_Num();
   return 0;
   }

void Ordinary_Function(cClass Function_Object)
   {
   cout << "Just entered function\n"; 
   
   Function_Object.Set_Num(30);
   Function_Object.Show_Num();   
   
   cout << "Just about to leave function\n";
   }
