// Program to find the sum of the squares of two numbers
// This time with error detection & recovery
// Source is: 25_13.CPP

#include <iostream.h>
#include <limits.h>

// Function declaration
int Sum_of_Squares5(const int, const int, int&);

int main()
    {
    int Num_1;
    int Num_2;
    int Result;

    do
       {
       cout << "Type first number : ";
       cin >> Num_1;
       cout << "Type second number : ";
       cin >> Num_2;
       } while (Sum_of_Squares5(Num_1, Num_2, Result));
     
    return 0;
    }
 
/***********************************************************
*   FUNCTION:  Sum_of_Squares5                             *
*                                                          *
*   OVERVIEW:  To calculate the sum of the squares         *
*              of a and b (both integers) returning the    *
*              result via reference variable sum_REF       *
*                                                          *
*   RETURNS:   0  on normal completion.                    *
*              1  if numbers too large (sum_REF =0)        *
***********************************************************/
int Sum_of_Squares5(const int A, const int B, int& sum_REF)
    {
    float Test = ((float) A * A) + ((float) B * B);

    if (Test > INT_MAX)
       {
       // Numbers too large: can't represent result as int
       cerr << "\n*** Numbers too large! ***\n\n";
       sum_REF = 0;
       return 1;
       }
    else
       {
       sum_REF = (int) Test;
       cout << "Sum of squares is : " << sum_REF;
       return 0;
       }     
    }
