// Returning an object from a function
// Source is: 25_16.CPP

#include <iostream.h>

class cClass
   {
   public:
           cClass() { cout << "Construct!" << endl; }
           ~cClass() { cout << "Destruct!" << endl; }
      void Set_Num(const int);
      void Show_Num() const; 
   private:
      int  _Num;
   };   

void cClass::Set_Num(const int NUMBER)
   {
   _Num = NUMBER;
   }

void cClass::Show_Num() const
   {
   cout << "number is " << _Num << endl;
   }

cClass Ordinary_Function(cClass);

int main()
   {
   cClass Object;

   Object.Set_Num(9);
   Object.Show_Num();

   (Ordinary_Function(Object)).Show_Num();
   
   Object.Show_Num();
   
   return 0;
   }

cClass Ordinary_Function(cClass FunctionObject)
   {
   cout << "Just entered function\n"; 
   
   FunctionObject.Set_Num(30);
   FunctionObject.Show_Num();   
   
   cout << "Just about to leave function\n";
   return FunctionObject;
   }
