// Another use of friend functions
// Here friend is a member function
// linking two classes
// Source is: 26_04.CPP

#include <iostream.h>

class cClass2; // Forward reference

class cClass1
   {
   public:
             void set(int);

      friend class cClass2; 
   private:
      int _num;
   };   

void cClass1::set(int number)
   {
   _num = number;
   }

class cClass2
   {
   public:
      void set(int);       
      void show(cClass1);
   private:
      int _num;
   };   

void cClass2::set(int number)
   {
   _num = number;
   }

void cClass2::show(cClass1 x)
   {
   cout << "Friendly sum is " << x._num + _num;
   }

int main()
   {
   cClass1 O1;
   cClass2 O2;
   
   O1.set(2001);
   O2.set(1999);
   
   // Call the show friend function
   O2.show(O1);
   
   return 0;
   }
