// A simple money class
// with overloaded + operator
// Source is: 27_04.CPP

#include <iostream.h>

class cMoney
   {
   public:
             cMoney(const int = 0, const int = 0);
      void   Show() const;
      cMoney operator+(const cMoney&) const;
   private:
      int    _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   _Pounds = PO;
   _Pence = PE;
   }   
   
void cMoney::Show() const
   {
   if (_Pence < 10)
      {
      cout << "" << _Pounds << ".0" << _Pence << endl;
      }
   else
      {
      cout << "" << _Pounds << "." << _Pence << endl;
      }   
   }        

// Overload + relative to cMoney class
cMoney cMoney::operator+(const cMoney& OBJ2) const
   {
   cMoney Sum;
   
   Sum._Pounds = this->_Pounds + OBJ2._Pounds;
   Sum._Pence = this->_Pence + OBJ2._Pence;
   
   while (Sum._Pence > 99)
      {
      Sum._Pence-=100;
      Sum._Pounds+=1;
      }     
   
   return Sum;
   }
   
int main()
   {
   cMoney cash1(1,33), cash2(2,90), cash3, cash4;
   
   // Explicit call of operator+ function
   cash3 = cash1.operator+(cash2);
   cash3.Show();

   // Implicit call of operator+ function
   cash3 = cash1 + cash2;
   cash3.Show();

   // Can add more than two objects...
   cash4 = cash1 + cash2 + cash3;
   cash4.Show();

   // Can also do this (if you want to...)
   (cash4 + cash4).Show();

   return 0;
   }
