// A simple money class
// with overloaded == operator
// Source is: 27_06.CPP

#include <iostream.h>

class cMoney
   {
   public:
      cMoney(const int = 0, const int = 0);
      void Show();
      
      int operator==(const cMoney&);
   private:
      int _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   _Pounds = PO;
   _Pence = PE;
   }   
   
void cMoney::Show()
   {
   if (_Pence < 10)
      {
      cout << "" << _Pounds << ".0" << _Pence;
      }
   else
      {
      cout << "" << _Pounds << "." << _Pence;
      }   
   }        
   
// Overload == relative to cMoney class
int cMoney::operator==(const cMoney& OBJ2)
   {
   if ((this->_Pounds == OBJ2._Pounds)&&(this->_Pence == OBJ2._Pence))
      {
      return 1;
      }
   else
      {
      return 0;
      }   
   }

int main()
   {
   cMoney cash1(1,33), cash2(2,90), cash3(1,33);
   
   cash1.Show();
   if (cash1 == cash2)
      {
      cout << " is the same as ";
      }
   else
      {
      cout << " is NOT the same as ";
      }
   cash2.Show(); 
   cout << endl;

   cash1.Show();
   if (cash1 == cash3)
      {
      cout << " is the same as ";
      }
   else
      {
      cout << " is NOT the same as ";
      }
   cash3.Show(); 
   cout << endl;
         
   return 0;
   }
