// Multiple inheritance
// Source is: 29_09.CPP

#include <iostream.h>

class cBase_Class1
   {
   public:
           cBase_Class1() { cout << "Cons base1 object\n"; }
           ~cBase_Class1() { cout << "Dest base1 object\n"; }
           
      void Set_b1(const int I) { _Prot_data_b1 = I;} 
      void Show_b1() const { cout << _Prot_data_b1 << endl;}

   protected:
      int _Prot_data_b1;  // Protected data - NOT recommended in real progs!
   };

class cBase_Class2
   {
   public:
           cBase_Class2() { cout << "Cons base2 object\n"; }
           ~cBase_Class2() { cout << "Dest base2 object\n"; }

      void Set_b2(const int I) { _Prot_data_b2 = I;} 
      void Show_b2() const { cout << _Prot_data_b2 << endl;}

   protected:
      int _Prot_data_b2;   // Protected data - NOT recommended in real progs!
   };

// Multiple (public) inheritance
class cDerived_Class : public cBase_Class2, public cBase_Class1
   {
   public:
           cDerived_Class() { cout << "Cons derived object\n";}
           ~cDerived_Class() { cout << "Dest derived object\n";}

      void Set_d(const int I) { _Der = I;} 
      void Show_d() const { cout << _Der << endl;}
      void Show_db1() const { cout << _Prot_data_b1 << endl;}
      void Show_db2() const { cout << _Prot_data_b2 << endl;}

   private:
      int _Der;
   };

int main()
   {
   cDerived_Class Object;

   Object.Set_b1(4);
   Object.Set_b2(6);
   Object.Set_d(8);

   Object.Show_d();
   Object.Show_db1();
   Object.Show_db2();

   return 0;
   }
