// Playing with virtual functions - run-time polymorphism
// Source is: 29_13.CPP

#include <iostream.h>

class cBase_Class 
   {
   public:
                   cBase_Class(const int B = 999){_Bas = B;}
      virtual void Show() const {cout<< "_Bas = " << _Bas << endl;}

   private:
      int _Bas;
   };

class cDerived_Class : public cBase_Class 
   {
   public:
           cDerived_Class(const char D = 'D') {_Der = D;}
      void show() const {cout << "_Der = " << _Der << endl;}

   private:
      char _Der;
   };


int main()
   {
   cBase_Class Base_object;
   cDerived_Class Derived_object;

   int Type;
   cBase_Class* General_PTR;

   cout << "Type 0 (base) or 1 (derived) :";
   cin >> Type;

   if (Type)
      {
      General_PTR = &Derived_object;
      }
   else
      {
      General_PTR = &Base_object;
      }

   General_PTR->Show();

   return 0;
   }
